import { connect, Dispatch } from 'react-redux';
import {
  SignIn,
  StateProps as SignInStateProps,
  DispatchProps as SigninDispatchProps,
} from './components/SignIn';
import State from '../redux/state/SignIn';

import * as signinActions from '../redux/action/signIn';
import { push as routerPush } from 'react-router-redux';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

export function mapStateToProps(state: any, ownProps?: any): SignInStateProps {
  return {
    isAuthenticated: state.isAuthenticated,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>, ownProps?: any): SigninDispatchProps {
  return {
    onSignIn: (signinId: string, signinPw: string) => {
      // dispatch(signinActions.request(signinId, signinPw));
      dispatch(asyncRequestActions.request('MemberService', 'signin', signinActions.REQUEST, signinId, signinPw));
    },
    onRedirectHome: () => {
      dispatch(routerPush('/'));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(SignIn);
